with Claw,
     Claw.Push_Button,
     Claw.Editbox_IO.String_IO,
     Claw.Dialog.Modal;
package Select_Dialog is

    -- This package implements a dialog to get Input string.

    --  -------------------------
    --  |   Title goes here     |
    --  |                       |
    --  |       Input           |
    --  |                       |
    --  |    OK    Cancel       |
    --  -------------------------

    subtype Input_Type is String(1 .. 4);  -- define size of input text.

    procedure Use_Dialog_Box (Owner  : in out Claw.Root_Window_Type'Class;
                              Title  : in     String;
                              OK     :    out Boolean;
                              Input  : in out Input_Type);
    -- Called from a menu selection and returns with Input and OK=True,
    -- or else with OK = False.
    -- The initial screen will display the initial value of Input.

private

    package IO_Box is new Claw.Editbox_IO.String_IO(Input_Type'length);

    type Dialog_Type is new Claw.Dialog.Modal.Modal_Dialog_Type with record
        Width       : Claw.Int;
        Input_Box   : IO_Box.Fixed_String_IO_Type;
        Input       : Input_Type;
        OK_Button   : Claw.Push_Button.Button_Type;
        Cancel_Button : Claw.Push_Button.Button_Type;
    end record;

    -- Override the following:
    procedure When_Initialize (Dialog : in out Dialog_Type;
                               Windows_Set_Focus : in out Boolean);

    procedure When_OK (Dialog : in out Dialog_Type);


end Select_Dialog;
